"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Karyotype(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "numberOfChromosomes",
        "participantId",
        "personKaryotipicSex",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import reports as reports_6_7_1

        return {
            "aneuploidies": reports_6_7_1.Aneuploidy,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import participant as participant_1_5_0

        return {
            "personKaryotipicSex": participant_1_5_0.PersonKaryotipicSex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import participant as participant_1_5_0
        from protocols.protocol_8_2 import reports as reports_6_7_1

        return {
            "org.gel.models.report.avro.Aneuploidy": reports_6_7_1.Aneuploidy,
            "org.gel.models.participant.avro.PersonKaryotipicSex": participant_1_5_0.PersonKaryotipicSex,
            "org.gel.models.report.avro.Karyotype": reports_6_7_1.Karyotype,
        }

    __slots__ = [
        "numberOfChromosomes",
        "participantId",
        "personKaryotipicSex",
        "aneuploidies",
        "description",
        "iscn",
    ]

    def __init__(
        self,
        numberOfChromosomes,
        participantId,
        personKaryotipicSex,
        aneuploidies=None,
        description=None,
        iscn=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_1.Karyotype model.

        :param numberOfChromosomes:
            Total number of chromosomes
        :type numberOfChromosomes: int
        :param participantId:
            Participant identifier
        :type participantId: str
        :param personKaryotipicSex:
            Kariotypic sex
        :type personKaryotipicSex: PersonKaryotipicSex
        :param aneuploidies:
            List of aneuploidies
        :type aneuploidies: None | list[Aneuploidy]
        :param description:
            Full description of the karyotype
        :type description: None | str
        :param iscn:
            International System for Human Cytogenetic Nomenclature (e.g.:
            "46,XY", "46,XY,-5,-12,+t(5pl2p),+t(5ql2q)")
        :type iscn: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.1"
